Func barcode_ean13 ($ps_data_in) ; barcode - code EAN 13
	Local $I,$J, $li_char, $li_checksum, $TableA, $la_data_out[16] ; array for possibility of writing to desired position - by the index

	if $ps_data_in = '' then return $ps_data_in

	$J = StringLen($ps_data_in)
	if $J <> 12 then return ''

	; only chars '0' .. '9'
	for $I=1 to $J
		$li_char = Asc(StringMid($ps_data_in,$I,1))
		if ($li_char < 48) or ($li_char > 57) then return ''
	next

	; calculate checksum
	for $I=2 to 12 step 2 ; even
		$li_char = Asc(StringMid($ps_data_in,$I,1))
		$li_checksum += $li_char - 48
	next
	$li_checksum = $li_checksum * 3

	for $I=1 to 11 step 2 ; odd
		$li_char = Asc(StringMid($ps_data_in,$I,1))
		$li_checksum += $li_char - 48
	next
	$li_checksum = Mod(10 - Mod($li_checksum,10),10)

	$li_char = Asc(StringLeft($ps_data_in,1)) - 48 ; first char
	for $I=3 to 7
		$TableA = False

		Switch $I
			case 3
				Switch $li_char
					case 0 To 3
						$TableA = True
				EndSwitch
			case 4
				Switch $li_char
					case 0, 4, 7, 8
						$TableA = True
				EndSwitch
			case 5
				Switch $li_char
					case 0, 1, 4, 5, 9
						$TableA = True
				EndSwitch
			case 6
				Switch $li_char
					case 0, 2, 5, 6, 7
						$TableA = True
				EndSwitch
			case 7
				Switch $li_char
					case 0, 3, 6, 8, 9
						$TableA = True
				EndSwitch
		EndSwitch

		If $TableA Then
			$la_data_out[$I] = Chr(Asc(StringMid($ps_data_in,$I,1)) + 17) ; 48 + 17 = 65
		Else
			$la_data_out[$I] = Chr(Asc(StringMid($ps_data_in,$I,1)) + 27) ; 48 + 27 = 75
		EndIf
	next

	for $I=9 to 13
		$la_data_out[$I] = Chr(Asc(StringMid($ps_data_in,$I - 1,1)) + 49) ; 48 + 49 = 97
	next

	; first char is taken as is, second from table A
	$la_data_out[1] = StringLeft($ps_data_in,1)
	$la_data_out[2] = Chr(Asc(StringMid($ps_data_in,2,1)) + 17) ; - 48 + 65
	$la_data_out[8] = '*'
	$la_data_out[14] = Chr($li_checksum + 97)
	$la_data_out[15] = '+'

	; copy composed array of chars into output string
	return __ArrayToString($la_data_out)
EndFunc

; optimized _ArrayToString()
Func __ArrayToString(Const ByRef $avArray)
	Local $sResult

	For $i = 1 To UBound($avArray) - 1
		$sResult &= $avArray[$i]
	Next

	Return $sResult
EndFunc
